uniform	mat4	u_ModelViewMatrix;
uniform	mat4	u_ModelViewProjectionMatrix;
uniform mat4	u_transformMatrix;
#if defined(CLIP)
	out	vec3	v_clipVertex;
#endif
out	vec2	texCoord;
out	vec3	Tangent;
out	vec3	Binormal;
out	vec3	Normal;
out	vec4	matColor;
#if defined(FAKE_PPL)
	out	vec2	lmCoord;
	out	vec3	vertexColor;
#endif
in	vec3	attr_Tangent;
in	vec3	attr_Binormal;
include deforms.inc
#if defined(FAKE_PPL)
	include colorGenLit.inc
#endif
include colorGenMat.inc
include tcGen_noFog.inc
void main(void)
{
	mat2 rmat;
	vec4 glVertex = DeformGeometry(rmat);
	tcGen(texCoord, glVertex.xyz);
	mat4 transformMatrix = mat4(rmat) * u_transformMatrix;
	Tangent = (transformMatrix * vec4(attr_Tangent, 0.0)).xyz;
	Binormal = (transformMatrix * vec4(attr_Binormal, 0.0)).xyz;
	Normal = (transformMatrix * vec4(attr_Normal, 0.0)).xyz;
	gl_Position = u_ModelViewProjectionMatrix * glVertex;
	include clipVertex.inc
#if defined(FAKE_PPL)
	lmCoord = attr_lightCoords;
	vertexColor = colorGenLit(glVertex.xyz, u_gen, u_parm0, u_parm1, u_parm2).rgb;
#endif
	matColor = colorGenMat(glVertex.xyz);
}
