uniform	mat4	u_ModelViewMatrix;
uniform	mat4	u_ModelViewProjectionMatrix;
uniform mat4	u_transformMatrix;
#if defined(CLIP)
	out	vec3	v_clipVertex;
#endif
out	vec4	texCoords;
out	vec3	Tangent;
out	vec3	Binormal;
out	vec3	Normal;
#if defined(FAKE_PPL)
	out	vec2	lmCoord;
	out	vec4	vertexColor;
#else
	out	float	vertexAlpha;
#endif
in	vec3	attr_Tangent;
in	vec3	attr_Binormal;
include		deforms.inc
include		colorGenLit.inc
include		tcGen_multitexture_noFog.inc
void main(void)
{
	mat2 rmat;
	vec4 glVertex = DeformGeometry(rmat);
	tcGen(texCoords.xy, texCoords.zw, glVertex.xyz);
	mat4 transformMatrix = mat4(rmat) * u_transformMatrix;
	Tangent = (transformMatrix * vec4(attr_Tangent, 0.0)).xyz;
	Binormal = (transformMatrix * vec4(attr_Binormal, 0.0)).xyz;
	Normal = (transformMatrix * vec4(attr_Normal, 0.0)).xyz;
	gl_Position = u_ModelViewProjectionMatrix * glVertex;
	include clipVertex.inc
#if defined(FAKE_PPL)
	lmCoord = attr_lightCoords;
	vertexColor = colorGenLit(glVertex.xyz, u_gen, u_parm0, u_parm1, u_parm2);
#else
	vertexAlpha = colorGenLit(glVertex.xyz, u_gen, u_parm0, u_parm1, u_parm2).a;
#endif
}
